--[[
Author: Starinnia
CPR is a combo points display addon based on Funkydude's BasicComboPoints
LunarShower.lua - A module for tracking Lunar Shower stacks
$Date: 2010-08-15 16:33:14 -0500 (Sun, 15 Aug 2010) $
$Revision: 136 $
Project Version: r178
contact: codemaster2010 AT gmail DOT com

Copyright (c) 2007-2010 Michael J. Murray aka Lyte of Lothar(US)
All rights reserved unless otherwise explicitly stated.
]]

if select(2, UnitClass("player")) ~= "DRUID" then return end

local cpr = LibStub("AceAddon-3.0"):GetAddon("ComboPointsRedux")
local modName = "Lunar Shower"
local LunarShowerModule = cpr:NewModule(modName, "AceConsole-3.0", "AceEvent-3.0")
local buff = GetSpellInfo(81192)

function LunarShowerModule:OnInitialize()
	self.abbrev = "LS"
	self.MAX_POINTS = 3
	self.displayName = buff
end

function LunarShowerModule:OnEnable()
	if not cpr.db.profile.modules[modName].disableGraphics then
		if not self.graphics then
			self.graphics = cpr:MakeGraphicsFrame(modName, self.MAX_POINTS)
		end
		self.graphics:Show()
	end
	if not cpr.db.profile.modules[modName].disableText then
		if not self.text then
			self.text = cpr:MakeTextFrame(modName)
		end
		self.text:Show()
	end
	
	self:RegisterEvent("UNIT_AURA")
end

function LunarShowerModule:OnDisable()
	if self.graphics then self.graphics:Hide() end
	if self.text then self.text:Hide() end
	self:UnregisterAllEvents()
end

function LunarShowerModule:UNIT_AURA(_, unit)
	if unit ~= "player" then return end
	
	local _, _, _, count = UnitBuff("player", buff)
	if count then
		if self.graphics then
			local r, g, b = cpr:GetColorByPoints(modName, count)
			for i = count, 1, -1 do
				self.graphics.points[i].icon:SetVertexColor(r, g, b)
				self.graphics.points[i]:Show()
			end
			for j = self.MAX_POINTS, count+1, -1 do
				self.graphics.points[j]:Hide()
			end
		end
		if self.text then self.text:SetNumPoints(count) end
	else
		if self.graphics then
			for i = 1, self.MAX_POINTS do
				self.graphics.points[i]:Hide()
			end
		end
		if self.text then self.text:SetNumPoints("") end
	end
end
